]> git.notmuchmail.org Git - notmuch/blob - test/test-lib.sh
616cb674ccd9ee36df8026a87805e28a5730f890
[notmuch] / test / test-lib.sh
1 #
2 # Copyright (c) 2005 Junio C Hamano
3 # Copyright (c) 2010 Notmuch Developers
4 #
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
9 #
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program.  If not, see https://www.gnu.org/licenses/ .
17
18 if [ ${BASH_VERSINFO[0]} -lt 4 ]; then
19     echo "Error: The notmuch test suite requires a bash version >= 4.0"
20     echo "due to use of associative arrays within the test suite."
21     echo "Please try again with a newer bash (or help us fix the"
22     echo "test suite to be more portable). Thanks."
23     exit 1
24 fi
25
26 # Make sure echo builtin does not expand backslash-escape sequences by default.
27 shopt -u xpg_echo
28
29 # Ensure NOTMUCH_SRCDIR and NOTMUCH_BUILDDIR are set.
30 . $(dirname "$0")/export-dirs.sh || exit 1
31
32 # It appears that people try to run tests without building...
33 if [[ ! -x "$NOTMUCH_BUILDDIR/notmuch" ]]; then
34         echo >&2 'You do not seem to have built notmuch yet.'
35         exit 1
36 fi
37
38 this_test=${0##*/}
39 this_test=${this_test%.sh}
40 this_test_bare=${this_test#T[0-9][0-9][0-9]-}
41
42 # if --tee was passed, write the output not only to the terminal, but
43 # additionally to the file test-results/$BASENAME.out, too.
44 case "$GIT_TEST_TEE_STARTED, $* " in
45 done,*)
46         # do not redirect again
47         ;;
48 *' --tee '*|*' --va'*)
49         mkdir -p test-results
50         BASE=test-results/$this_test
51         (GIT_TEST_TEE_STARTED=done "$BASH" "$0" "$@" 2>&1;
52          echo $? > $BASE.exit) | tee $BASE.out
53         test "$(cat $BASE.exit)" = 0
54         exit
55         ;;
56 esac
57
58 # STDIN from /dev/null. EOF for readers (and ENOTTY for tty related ioctls).
59 exec </dev/null
60
61 # Save STDOUT to fd 6 and STDERR to fd 7.
62 exec 6>&1 7>&2
63 # Make xtrace debugging (when used) use redirected STDERR, with verbose lead:
64 BASH_XTRACEFD=7
65 export PS4='+(${BASH_SOURCE}:${LINENO}): ${FUNCNAME[0]:+${FUNCNAME[0]}(): }'
66
67 # Keep the original TERM for say_color and test_emacs
68 ORIGINAL_TERM=$TERM
69
70 # Set SMART_TERM to vt100 for known dumb/unknown terminal.
71 # Otherwise use whatever TERM is currently used so that
72 # users' actual TERM environments are being used in tests.
73 case ${TERM-} in
74         '' | dumb | unknown )
75                 SMART_TERM=vt100 ;;
76         *)
77                 SMART_TERM=$TERM ;;
78 esac
79
80 # For repeatability, reset the environment to known value.
81 LANG=C
82 LC_ALL=C
83 PAGER=cat
84 TZ=UTC
85 TERM=dumb
86 export LANG LC_ALL PAGER TERM TZ
87 GIT_TEST_CMP=${GIT_TEST_CMP:-diff -u}
88 if [[ ( -n "$TEST_EMACS" && -z "$TEST_EMACSCLIENT" ) || \
89       ( -z "$TEST_EMACS" && -n "$TEST_EMACSCLIENT" ) ]]; then
90     echo "error: must specify both or neither of TEST_EMACS and TEST_EMACSCLIENT" >&2
91     exit 1
92 fi
93 TEST_EMACS=${TEST_EMACS:-${EMACS:-emacs}}
94 TEST_EMACSCLIENT=${TEST_EMACSCLIENT:-emacsclient}
95 TEST_GDB=${TEST_GDB:-gdb}
96 TEST_CC=${TEST_CC:-cc}
97 TEST_CFLAGS=${TEST_CFLAGS:-"-g -O0"}
98
99 # Protect ourselves from common misconfiguration to export
100 # CDPATH into the environment
101 unset CDPATH
102
103 unset GREP_OPTIONS
104
105 # For emacsclient
106 unset ALTERNATE_EDITOR
107
108 add_gnupg_home ()
109 {
110     local output
111     [ -d ${GNUPGHOME} ] && return
112     _gnupg_exit () { gpgconf --kill all 2>/dev/null || true; }
113     at_exit_function _gnupg_exit
114     mkdir -m 0700 "$GNUPGHOME"
115     gpg --no-tty --import <$NOTMUCH_SRCDIR/test/gnupg-secret-key.asc >"$GNUPGHOME"/import.log 2>&1
116     test_debug "cat $GNUPGHOME/import.log"
117     if (gpg --quick-random --version >/dev/null 2>&1) ; then
118         echo quick-random >> "$GNUPGHOME"/gpg.conf
119     elif (gpg --debug-quick-random --version >/dev/null 2>&1) ; then
120         echo debug-quick-random >> "$GNUPGHOME"/gpg.conf
121     fi
122     echo no-emit-version >> "$GNUPGHOME"/gpg.conf
123
124     # Change this if we ship a new test key
125     FINGERPRINT="5AEAB11F5E33DCE875DDB75B6D92612D94E46381"
126     SELF_USERID="Notmuch Test Suite <test_suite@notmuchmail.org> (INSECURE!)"
127     printf '%s:6:\n' "$FINGERPRINT" | gpg --quiet --batch --no-tty --import-ownertrust
128 }
129
130 # Each test should start with something like this, after copyright notices:
131 #
132 # test_description='Description of this test...
133 # This test checks if command xyzzy does the right thing...
134 # '
135 # . ./test-lib.sh || exit 1
136
137 color=maybe
138
139 while test "$#" -ne 0
140 do
141         case "$1" in
142         -d|--debug)
143                 debug=t; shift ;;
144         -i|--immediate)
145                 immediate=t; shift ;;
146         -h|--help)
147                 help=t; shift ;;
148         -v|--verbose)
149                 verbose=t; shift ;;
150         -q|--quiet)
151                 quiet=t; shift ;;
152         --with-dashes)
153                 with_dashes=t; shift ;;
154         --no-color)
155                 color=; shift ;;
156         --no-python)
157                 # noop now...
158                 shift ;;
159         --valgrind)
160                 valgrind=t; verbose=t; shift ;;
161         --tee)
162                 shift ;; # was handled already
163         *)
164                 echo "error: unknown test option '$1'" >&2; exit 1 ;;
165         esac
166 done
167
168 if test -n "$debug"; then
169     print_subtest () {
170         printf " %-4s" "[$((test_count - 1))]"
171     }
172 else
173     print_subtest () {
174         true
175     }
176 fi
177
178 test -n "$COLORS_WITHOUT_TTY" || [ -t 1 ] || color=
179
180 if [ -n "$color" ] && [ "$ORIGINAL_TERM" != 'dumb' ] && (
181                 TERM=$ORIGINAL_TERM &&
182                 export TERM &&
183                 tput bold
184                 tput setaf
185                 tput sgr0
186         ) >/dev/null 2>&1
187 then
188         color=t
189 else
190         color=
191 fi
192
193 if test -n "$color"; then
194         say_color () {
195                 (
196                 TERM=$ORIGINAL_TERM
197                 export TERM
198                 case "$1" in
199                         error) tput bold; tput setaf 1;; # bold red
200                         skip)  tput bold; tput setaf 2;; # bold green
201                         pass)  tput setaf 2;;            # green
202                         info)  tput setaf 3;;            # brown
203                         *) test -n "$quiet" && return;;
204                 esac
205                 shift
206                 printf " "
207                 printf "$@"
208                 tput sgr0
209                 print_subtest
210                 )
211         }
212 else
213         say_color() {
214                 test -z "$1" && test -n "$quiet" && return
215                 shift
216                 printf " "
217                 printf "$@"
218                 print_subtest
219         }
220 fi
221
222 error () {
223         say_color error "error: $*\n"
224         GIT_EXIT_OK=t
225         exit 1
226 }
227
228 say () {
229         say_color info "$*"
230 }
231
232 test "${test_description}" != "" ||
233 error "Test script did not set test_description."
234
235 if test "$help" = "t"
236 then
237         echo "Tests ${test_description}"
238         exit 0
239 fi
240
241 test_description_printed=
242 print_test_description ()
243 {
244         test -z "$test_description_printed" || return 0
245         echo
246         echo $this_test: "Testing ${test_description}"
247         test_description_printed=1
248 }
249 if [ -z "$NOTMUCH_TEST_QUIET" ]
250 then
251         print_test_description
252 fi
253
254 test_failure=0
255 test_count=0
256 test_fixed=0
257 test_broken=0
258 test_success=0
259
260 declare -a _exit_functions=()
261
262 at_exit_function () {
263         _exit_functions=($1 ${_exit_functions[@]/$1})
264 }
265
266 rm_exit_function () {
267         _exit_functions=(${_exit_functions[@]/$1})
268 }
269
270 _exit_common () {
271         code=$?
272         trap - EXIT
273         set +ex
274         for _fn in ${_exit_functions[@]}; do $_fn; done
275         rm -rf "$TEST_TMPDIR"
276 }
277
278 trap_exit () {
279         _exit_common
280         if test -n "$GIT_EXIT_OK"
281         then
282                 exit $code
283         else
284                 exec >&6
285                 say_color error '%-6s' FATAL
286                 echo " $test_subtest_name"
287                 echo
288                 echo "Unexpected exit while executing $0. Exit code $code."
289                 exit 1
290         fi
291 }
292
293 trap_signal () {
294         _exit_common
295         echo >&6 "FATAL: $0: interrupted by signal" $((code - 128))
296         exit $code
297 }
298
299 die () {
300         _exit_common
301         exec >&6
302         say_color error '%-6s' FATAL
303         echo " $*"
304         echo
305         echo "Unexpected exit while executing $0."
306         exit 1
307 }
308
309 GIT_EXIT_OK=
310 # Note: TEST_TMPDIR *NOT* exported!
311 TEST_TMPDIR=$(mktemp -d "${TMPDIR:-/tmp}/notmuch-test-$$.XXXXXX")
312 # Put GNUPGHOME in TMPDIR to avoid problems with long paths.
313 export GNUPGHOME="${TEST_TMPDIR}/gnupg"
314 trap 'trap_exit' EXIT
315 trap 'trap_signal' HUP INT TERM
316
317 # Deliver a message with emacs and add it to the database
318 #
319 # Uses emacs to generate and deliver a message to the mail store.
320 # Accepts arbitrary extra emacs/elisp functions to modify the message
321 # before sending, which is useful to doing things like attaching files
322 # to the message and encrypting/signing.
323 emacs_deliver_message ()
324 {
325     local subject="$1"
326     local body="$2"
327     shift 2
328     # before we can send a message, we have to prepare the FCC maildir
329     mkdir -p "$MAIL_DIR"/sent/{cur,new,tmp}
330     # eval'ing smtp-dummy --background will set smtp_dummy_pid and -_port
331     local smtp_dummy_pid= smtp_dummy_port=
332     eval `$TEST_DIRECTORY/smtp-dummy --background sent_message`
333     test -n "$smtp_dummy_pid" || return 1
334     test -n "$smtp_dummy_port" || return 1
335
336     test_emacs \
337         "(let ((message-send-mail-function 'message-smtpmail-send-it)
338                (mail-host-address \"example.com\")
339                (smtpmail-smtp-server \"localhost\")
340                (smtpmail-smtp-service \"${smtp_dummy_port}\"))
341            (notmuch-mua-mail)
342            (message-goto-to)
343            (insert \"test_suite@notmuchmail.org\nDate: 01 Jan 2000 12:00:00 -0000\")
344            (message-goto-subject)
345            (insert \"${subject}\")
346            (message-goto-body)
347            (insert \"${body}\")
348            $*
349            (notmuch-mua-send-and-exit))"
350
351     # In case message was sent properly, client waits for confirmation
352     # before exiting and resuming control here; therefore making sure
353     # that server exits by sending (KILL) signal to it is safe.
354     kill -9 $smtp_dummy_pid
355     notmuch new >/dev/null
356 }
357
358 # Pretend to deliver a message with emacs. Really save it to a file
359 # and add it to the database
360 #
361 # Uses emacs to generate and deliver a message to the mail store.
362 # Accepts arbitrary extra emacs/elisp functions to modify the message
363 # before sending, which is useful to doing things like attaching files
364 # to the message and encrypting/signing.
365 #
366 # If any GNU-style long-arguments (like --quiet or --decrypt=true) are
367 # at the head of the argument list, they are sent directly to "notmuch
368 # new" after message delivery
369 emacs_fcc_message ()
370 {
371     local nmn_args=''
372     while [[ "$1" =~ ^-- ]]; do
373         nmn_args="$nmn_args $1"
374         shift
375     done
376     local subject="$1"
377     local body="$2"
378     shift 2
379     # before we can send a message, we have to prepare the FCC maildir
380     mkdir -p "$MAIL_DIR"/sent/{cur,new,tmp}
381
382     test_emacs \
383         "(let ((message-send-mail-function (lambda () t))
384                (mail-host-address \"example.com\"))
385            (notmuch-mua-mail)
386            (message-goto-to)
387            (insert \"test_suite@notmuchmail.org\nDate: 01 Jan 2000 12:00:00 -0000\")
388            (message-goto-subject)
389            (insert \"${subject}\")
390            (message-goto-body)
391            (insert \"${body}\")
392            $*
393            (notmuch-mua-send-and-exit))" || return 1
394     notmuch new $nmn_args >/dev/null
395 }
396
397 # Add an existing, fixed corpus of email to the database.
398 #
399 # $1 is the corpus dir under corpora to add, using "default" if unset.
400 #
401 # The default corpus is based on about 50 messages from early in the
402 # history of the notmuch mailing list, which allows for reliably
403 # testing commands that need to operate on a not-totally-trivial
404 # number of messages.
405 add_email_corpus ()
406 {
407     corpus=${1:-default}
408
409     rm -rf ${MAIL_DIR}
410     cp -a $NOTMUCH_SRCDIR/test/corpora/$corpus ${MAIL_DIR}
411     notmuch new >/dev/null || die "'notmuch new' failed while adding email corpus"
412 }
413
414 test_begin_subtest ()
415 {
416     if [ -n "$inside_subtest" ]; then
417         exec 1>&6 2>&7          # Restore stdout and stderr
418         error "bug in test script: Missing test_expect_equal in ${BASH_SOURCE[1]}:${BASH_LINENO[0]}"
419     fi
420     test_subtest_name="$1"
421     test_reset_state_
422     # Redirect test output to the previously prepared file descriptors
423     # 3 and 4 (see below)
424     if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
425     exec >&3 2>&4
426     inside_subtest=t
427 }
428
429 # Pass test if two arguments match
430 #
431 # Note: Unlike all other test_expect_* functions, this function does
432 # not accept a test name. Instead, the caller should call
433 # test_begin_subtest before calling this function in order to set the
434 # name.
435 test_expect_equal ()
436 {
437         exec 1>&6 2>&7          # Restore stdout and stderr
438         if [ -z "$inside_subtest" ]; then
439                 error "bug in the test script: test_expect_equal without test_begin_subtest"
440         fi
441         inside_subtest=
442         test "$#" = 2 ||
443         error "bug in the test script: not 2 parameters to test_expect_equal"
444
445         output="$1"
446         expected="$2"
447         if ! test_skip "$test_subtest_name"
448         then
449                 if [ "$output" = "$expected" ]; then
450                         test_ok_
451                 else
452                         testname=$this_test.$test_count
453                         echo "$expected" > $testname.expected
454                         echo "$output" > $testname.output
455                         test_failure_ "$(diff -u $testname.expected $testname.output)"
456                 fi
457     fi
458 }
459
460 # Like test_expect_equal, but takes two filenames.
461 test_expect_equal_file ()
462 {
463         exec 1>&6 2>&7          # Restore stdout and stderr
464         if [ -z "$inside_subtest" ]; then
465                 error "bug in the test script: test_expect_equal_file without test_begin_subtest"
466         fi
467         inside_subtest=
468         test "$#" = 2 ||
469         error "bug in the test script: not 2 parameters to test_expect_equal_file"
470
471         file1="$1"
472         file2="$2"
473         if ! test_skip "$test_subtest_name"
474         then
475                 if diff -q "$file1" "$file2" >/dev/null ; then
476                         test_ok_
477                 else
478                         testname=$this_test.$test_count
479                         basename1=`basename "$file1"`
480                         basename2=`basename "$file2"`
481                         cp "$file1" "$testname.$basename1"
482                         cp "$file2" "$testname.$basename2"
483                         test_failure_ "$(diff -u "$testname.$basename1" "$testname.$basename2")"
484                 fi
485     fi
486 }
487
488 # Like test_expect_equal, but arguments are JSON expressions to be
489 # canonicalized before diff'ing.  If an argument cannot be parsed, it
490 # is used unchanged so that there's something to diff against.
491 test_expect_equal_json () {
492     # The test suite forces LC_ALL=C, but this causes Python 3 to
493     # decode stdin as ASCII.  We need to read JSON in UTF-8, so
494     # override Python's stdio encoding defaults.
495     local script='import json, sys; json.dump(json.load(sys.stdin), sys.stdout, sort_keys=True, indent=4)'
496     output=$(echo "$1" | PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c "$script" \
497         || echo "$1")
498     expected=$(echo "$2" | PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c "$script" \
499         || echo "$2")
500     shift 2
501     test_expect_equal "$output" "$expected" "$@"
502 }
503
504 # Sort the top-level list of JSON data from stdin.
505 test_sort_json () {
506     PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c \
507         "import sys, json; json.dump(sorted(json.load(sys.stdin)),sys.stdout)"
508 }
509
510 # test for json objects:
511 # read the source of test/json_check_nodes.py (or the output when
512 # invoking it without arguments) for an explanation of the syntax.
513 test_json_nodes () {
514         exec 1>&6 2>&7          # Restore stdout and stderr
515         if [ -z "$inside_subtest" ]; then
516                 error "bug in the test script: test_json_eval without test_begin_subtest"
517         fi
518         inside_subtest=
519         test "$#" > 0 ||
520             error "bug in the test script: test_json_nodes needs at least 1 parameter"
521
522         if ! test_skip "$test_subtest_name"
523         then
524             output=$(PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON "$TEST_DIRECTORY"/json_check_nodes.py "$@")
525                 if [ "$?" = 0 ]
526                 then
527                         test_ok_
528                 else
529                         test_failure_ "$output"
530                 fi
531         fi
532 }
533
534 test_emacs_expect_t () {
535         test "$#" = 1 ||
536         error "bug in the test script: not 1 parameter to test_emacs_expect_t"
537         if [ -z "$inside_subtest" ]; then
538                 error "bug in the test script: test_emacs_expect_t without test_begin_subtest"
539         fi
540
541         # Run the test.
542         if ! test_skip "$test_subtest_name"
543         then
544                 test_emacs "(notmuch-test-run $1)" >/dev/null
545
546                 # Restore state after the test.
547                 exec 1>&6 2>&7          # Restore stdout and stderr
548                 inside_subtest=
549
550                 # Report success/failure.
551                 result=$(cat OUTPUT)
552                 if [ "$result" = t ]
553                 then
554                         test_ok_
555                 else
556                         test_failure_ "${result}"
557                 fi
558         else
559                 # Restore state after the (non) test.
560                 exec 1>&6 2>&7          # Restore stdout and stderr
561                 inside_subtest=
562         fi
563 }
564
565 NOTMUCH_NEW ()
566 {
567     notmuch new "${@}" | grep -v -E -e '^Processed [0-9]*( total)? file|Found [0-9]* total file'
568 }
569
570 NOTMUCH_DUMP_TAGS ()
571 {
572     # this relies on the default format being batch-tag, otherwise some tests will break
573     notmuch dump --include=tags "${@}" | sed '/^#/d' | sort
574 }
575
576 notmuch_drop_mail_headers ()
577 {
578     $NOTMUCH_PYTHON -c '
579 import email, sys
580 msg = email.message_from_file(sys.stdin)
581 for hdr in sys.argv[1:]: del msg[hdr]
582 print(msg.as_string(False))
583 ' "$@"
584 }
585
586 notmuch_search_sanitize ()
587 {
588     perl -pe 's/("?thread"?: ?)("?)................("?)/\1\2XXX\3/'
589 }
590
591 notmuch_search_files_sanitize ()
592 {
593     notmuch_dir_sanitize
594 }
595
596 notmuch_dir_sanitize ()
597 {
598     sed -e "s,$MAIL_DIR,MAIL_DIR," -e "s,${PWD},CWD,g" "$@"
599 }
600
601 NOTMUCH_SHOW_FILENAME_SQUELCH='s,filename:.*/mail,filename:/XXX/mail,'
602 notmuch_show_sanitize ()
603 {
604     sed -e "$NOTMUCH_SHOW_FILENAME_SQUELCH"
605 }
606 notmuch_show_sanitize_all ()
607 {
608     sed \
609         -e 's| filename:.*| filename:XXXXX|' \
610         -e 's| id:[^ ]* | id:XXXXX |' | \
611         notmuch_date_sanitize
612 }
613
614 notmuch_json_show_sanitize ()
615 {
616     sed \
617         -e 's|"id": "[^"]*",|"id": "XXXXX",|g' \
618         -e 's|"Date": "Fri, 05 Jan 2001 [^"]*0000"|"Date": "GENERATED_DATE"|g' \
619         -e 's|"filename": "signature.asc",||g' \
620         -e 's|"filename": \["/[^"]*"\],|"filename": \["YYYYY"\],|g' \
621         -e 's|"timestamp": 97.......|"timestamp": 42|g' \
622         -e 's|"content-length": [1-9][0-9]*|"content-length": "NONZERO"|g'
623 }
624
625 notmuch_emacs_error_sanitize ()
626 {
627     local command=$1
628     shift
629     for file in "$@"; do
630         echo "=== $file ==="
631         cat "$file"
632     done | sed  \
633         -e 's/^\[.*\]$/[XXX]/' \
634         -e "s|^\(command: \)\{0,1\}/.*/$command|\1YYY/$command|"
635 }
636
637 notmuch_date_sanitize ()
638 {
639     sed \
640         -e 's/^Date: Fri, 05 Jan 2001 .*0000/Date: GENERATED_DATE/'
641 }
642
643 notmuch_uuid_sanitize ()
644 {
645     sed 's/[0-9a-f]\{8\}-[0-9a-f]\{4\}-[0-9a-f]\{4\}-[0-9a-f]\{4\}-[0-9a-f]\{12\}/UUID/g'
646 }
647
648 notmuch_built_with_sanitize ()
649 {
650     sed 's/^built_with[.]\(.*\)=.*$/built_with.\1=something/'
651 }
652
653 notmuch_config_sanitize ()
654 {
655     notmuch_dir_sanitize | notmuch_built_with_sanitize
656 }
657
658 notmuch_show_part ()
659 {
660     awk '/^\014part}/{ f=0 }; { if (f) { print $0 } } /^\014part{ ID: '"$1"'/{ f=1 }'
661 }
662
663 # End of notmuch helper functions
664
665 # Use test_set_prereq to tell that a particular prerequisite is available.
666 #
667 # The prerequisite can later be checked for by using test_have_prereq.
668 #
669 # The single parameter is the prerequisite tag (a simple word, in all
670 # capital letters by convention).
671
672 test_set_prereq () {
673         satisfied="$satisfied$1 "
674 }
675 satisfied=" "
676
677 test_have_prereq () {
678         case $satisfied in
679         *" $1 "*)
680                 : yes, have it ;;
681         *)
682                 ! : nope ;;
683         esac
684 }
685
686 declare -A test_missing_external_prereq_
687 declare -A test_subtest_missing_external_prereq_
688
689 # declare prerequisite for the given external binary
690 test_declare_external_prereq () {
691         binary="$1"
692         test "$#" = 2 && name=$2 || name="$binary(1)"
693
694         if ! hash $binary 2>/dev/null; then
695                 test_missing_external_prereq_["${binary}"]=t
696                 eval "
697 $binary () {
698         test_subtest_missing_external_prereq_[\"${name}\"]=t
699         false
700 }"
701         fi
702 }
703
704 # Explicitly require external prerequisite.  Useful when binary is
705 # called indirectly (e.g. from emacs).
706 # Returns success if dependency is available, failure otherwise.
707 test_require_external_prereq () {
708         binary="$1"
709         if [[ ${test_missing_external_prereq_["${binary}"]} == t ]]; then
710                 # dependency is missing, call the replacement function to note it
711                 eval "$binary"
712         else
713                 true
714         fi
715 }
716
717 # You are not expected to call test_ok_ and test_failure_ directly, use
718 # the text_expect_* functions instead.
719
720 test_ok_ () {
721         if test "$test_subtest_known_broken_" = "t"; then
722                 test_known_broken_ok_
723                 return
724         fi
725         test_success=$(($test_success + 1))
726         if test -n "$NOTMUCH_TEST_QUIET"; then
727                 return 0
728         fi
729         say_color pass "%-6s" "PASS"
730         echo " $test_subtest_name"
731 }
732
733 test_failure_ () {
734         print_test_description
735         if test "$test_subtest_known_broken_" = "t"; then
736                 test_known_broken_failure_ "$@"
737                 return
738         fi
739         test_failure=$(($test_failure + 1))
740         test_failure_message_ "FAIL" "$test_subtest_name" "$@"
741         test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
742         return 1
743 }
744
745 test_failure_message_ () {
746         say_color error "%-6s" "$1"
747         echo " $2"
748         shift 2
749         if [ "$#" != "0" ]; then
750                 echo "$@" | sed -e 's/^/        /'
751         fi
752         if test "$verbose" != "t"; then cat test.output; fi
753 }
754
755 test_known_broken_ok_ () {
756         test_reset_state_
757         test_fixed=$(($test_fixed+1))
758         say_color pass "%-6s" "FIXED"
759         echo " $test_subtest_name"
760 }
761
762 test_known_broken_failure_ () {
763         test_reset_state_
764         test_broken=$(($test_broken+1))
765         if [ -z "$NOTMUCH_TEST_QUIET" ]; then
766                 test_failure_message_ "BROKEN" "$test_subtest_name" "$@"
767         else
768                 test_failure_message_ "BROKEN" "$test_subtest_name"
769         fi
770         return 1
771 }
772
773 test_debug () {
774         test "$debug" = "" || eval "$1"
775 }
776
777 test_run_ () {
778         test_cleanup=:
779         if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
780         eval >&3 2>&4 "$1"
781         eval_ret=$?
782         eval >&3 2>&4 "$test_cleanup"
783         return 0
784 }
785
786 test_skip () {
787         test_count=$(($test_count+1))
788         to_skip=
789         for skp in $NOTMUCH_SKIP_TESTS
790         do
791                 case $this_test.$test_count in
792                 $skp)
793                         to_skip=t
794                         break
795                 esac
796                 case $this_test_bare.$test_count in
797                 $skp)
798                         to_skip=t
799                         break
800                 esac
801         done
802         case "$to_skip" in
803         t)
804                 test_report_skip_ "$@"
805                 ;;
806         *)
807                 test_check_missing_external_prereqs_ "$@"
808                 ;;
809         esac
810 }
811
812 test_check_missing_external_prereqs_ () {
813         if [[ ${#test_subtest_missing_external_prereq_[@]} != 0 ]]; then
814                 say_color skip >&1 "missing prerequisites: "
815                 echo ${!test_subtest_missing_external_prereq_[@]} >&1
816                 test_report_skip_ "$@"
817         else
818                 false
819         fi
820 }
821
822 test_report_skip_ () {
823         test_reset_state_
824         say_color skip >&3 "skipping test:"
825         echo " $@" >&3
826         say_color skip "%-6s" "SKIP"
827         echo " $1"
828 }
829
830 test_subtest_known_broken () {
831         test_subtest_known_broken_=t
832 }
833
834 test_expect_success () {
835         exec 1>&6 2>&7          # Restore stdout and stderr
836         if [ -z "$inside_subtest" ]; then
837                 error "bug in the test script: test_expect_success without test_begin_subtest"
838         fi
839         inside_subtest=
840         test "$#" = 1 ||
841         error "bug in the test script: not 1 parameters to test_expect_success"
842
843         if ! test_skip "$test_subtest_name"
844         then
845                 test_run_ "$1"
846                 run_ret="$?"
847                 # test_run_ may update missing external prerequisites
848                 test_check_missing_external_prereqs_ "$@" ||
849                 if [ "$run_ret" = 0 -a "$eval_ret" = 0 ]
850                 then
851                         test_ok_
852                 else
853                         test_failure_ "$1"
854                 fi
855         fi
856 }
857
858 test_expect_code () {
859         exec 1>&6 2>&7          # Restore stdout and stderr
860         if [ -z "$inside_subtest" ]; then
861                 error "bug in the test script: test_expect_code without test_begin_subtest"
862         fi
863         inside_subtest=
864         test "$#" = 2 ||
865         error "bug in the test script: not 2 parameters to test_expect_code"
866
867         if ! test_skip "$test_subtest_name"
868         then
869                 test_run_ "$2"
870                 run_ret="$?"
871                 # test_run_ may update missing external prerequisites,
872                 test_check_missing_external_prereqs_ "$@" ||
873                 if [ "$run_ret" = 0 -a "$eval_ret" = "$1" ]
874                 then
875                         test_ok_
876                 else
877                         test_failure_ "exit code $eval_ret, expected $1" "$2"
878                 fi
879         fi
880 }
881
882 # This is not among top-level (test_expect_success)
883 # but is a prefix that can be used in the test script, like:
884 #
885 #       test_expect_success 'complain and die' '
886 #           do something &&
887 #           do something else &&
888 #           test_must_fail git checkout ../outerspace
889 #       '
890 #
891 # Writing this as "! git checkout ../outerspace" is wrong, because
892 # the failure could be due to a segv.  We want a controlled failure.
893
894 test_must_fail () {
895         "$@"
896         test $? -gt 0 -a $? -le 129 -o $? -gt 192
897 }
898
899 # test_cmp is a helper function to compare actual and expected output.
900 # You can use it like:
901 #
902 #       test_expect_success 'foo works' '
903 #               echo expected >expected &&
904 #               foo >actual &&
905 #               test_cmp expected actual
906 #       '
907 #
908 # This could be written as either "cmp" or "diff -u", but:
909 # - cmp's output is not nearly as easy to read as diff -u
910 # - not all diff versions understand "-u"
911
912 test_cmp() {
913         $GIT_TEST_CMP "$@"
914 }
915
916 # This function can be used to schedule some commands to be run
917 # unconditionally at the end of the test to restore sanity:
918 #
919 #       test_expect_success 'test core.capslock' '
920 #               git config core.capslock true &&
921 #               test_when_finished "git config --unset core.capslock" &&
922 #               hello world
923 #       '
924 #
925 # That would be roughly equivalent to
926 #
927 #       test_expect_success 'test core.capslock' '
928 #               git config core.capslock true &&
929 #               hello world
930 #               git config --unset core.capslock
931 #       '
932 #
933 # except that the greeting and config --unset must both succeed for
934 # the test to pass.
935
936 test_when_finished () {
937         test_cleanup="{ $*
938                 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
939 }
940
941 test_done () {
942         GIT_EXIT_OK=t
943         test_results_dir="$TEST_DIRECTORY/test-results"
944         mkdir -p "$test_results_dir"
945         test_results_path="$test_results_dir/$this_test"
946
947         echo "total $test_count" >> $test_results_path
948         echo "success $test_success" >> $test_results_path
949         echo "fixed $test_fixed" >> $test_results_path
950         echo "broken $test_broken" >> $test_results_path
951         echo "failed $test_failure" >> $test_results_path
952         echo "" >> $test_results_path
953
954         [ -n "$EMACS_SERVER" ] && test_emacs '(kill-emacs)'
955
956         if [ "$test_failure" = "0" ]; then
957             if [ "$test_broken" = "0" ]; then
958                 rm -rf "$remove_tmp"
959             fi
960             exit 0
961         else
962             exit 1
963         fi
964 }
965
966 emacs_generate_script () {
967         # Construct a little test script here for the benefit of the user,
968         # (who can easily run "run_emacs" to get the same emacs environment
969         # for investigating any failures).
970         cat <<EOF >"$TMP_DIRECTORY/run_emacs"
971 #!/bin/sh
972 export PATH=$PATH
973 export NOTMUCH_CONFIG=$NOTMUCH_CONFIG
974
975 # Here's what we are using here:
976 #
977 # --quick              Use minimal customization. This implies --no-init-file,
978 #                      --no-site-file and (emacs 24) --no-site-lisp
979 #
980 # --directory           Ensure that the local elisp sources are found
981 #
982 # --load                Force loading of notmuch.el and test-lib.el
983
984 exec ${TEST_EMACS} --quick \
985         --directory "$NOTMUCH_SRCDIR/emacs" --load notmuch.el \
986         --directory "$NOTMUCH_SRCDIR/test" --load test-lib.el \
987         "\$@"
988 EOF
989         chmod a+x "$TMP_DIRECTORY/run_emacs"
990 }
991
992 test_emacs () {
993         # test dependencies beforehand to avoid the waiting loop below
994         missing_dependencies=
995         test_require_external_prereq dtach || missing_dependencies=1
996         test_require_external_prereq emacs || missing_dependencies=1
997         test_require_external_prereq ${TEST_EMACSCLIENT} || missing_dependencies=1
998         test -z "$missing_dependencies" || return
999
1000         if [ -z "$EMACS_SERVER" ]; then
1001                 emacs_tests="$NOTMUCH_SRCDIR/test/${this_test_bare}.el"
1002                 if [ -f "$emacs_tests" ]; then
1003                         load_emacs_tests="--eval '(load \"$emacs_tests\")'"
1004                 else
1005                         load_emacs_tests=
1006                 fi
1007                 server_name="notmuch-test-suite-$$"
1008                 # start a detached session with an emacs server
1009                 # user's TERM (or 'vt100' in case user's TERM is known dumb
1010                 # or unknown) is given to dtach which assumes a minimally
1011                 # VT100-compatible terminal -- and emacs inherits that
1012                 TERM=$SMART_TERM dtach -n "$TEST_TMPDIR/emacs-dtach-socket.$$" \
1013                         sh -c "stty rows 24 cols 80; exec '$TMP_DIRECTORY/run_emacs' \
1014                                 --no-window-system \
1015                                 $load_emacs_tests \
1016                                 --eval '(setq server-name \"$server_name\")' \
1017                                 --eval '(server-start)' \
1018                                 --eval '(orphan-watchdog $$)'" || return
1019                 EMACS_SERVER="$server_name"
1020                 # wait until the emacs server is up
1021                 until test_emacs '()' >/dev/null 2>/dev/null; do
1022                         sleep 1
1023                 done
1024         fi
1025
1026         # Clear test-output output file.  Most Emacs tests end with a
1027         # call to (test-output).  If the test code fails with an
1028         # exception before this call, the output file won't get
1029         # updated.  Since we don't want to compare against an output
1030         # file from another test, so start out with an empty file.
1031         rm -f OUTPUT
1032         touch OUTPUT
1033
1034         ${TEST_EMACSCLIENT} --socket-name="$EMACS_SERVER" --eval "(notmuch-test-progn $*)"
1035 }
1036
1037 test_python() {
1038     # Note: if there is need to print debug information from python program,
1039     # use stdout = os.fdopen(6, 'w') or stderr = os.fdopen(7, 'w')
1040     PYTHONPATH="$NOTMUCH_SRCDIR/bindings/python${PYTHONPATH:+:$PYTHONPATH}" \
1041         $NOTMUCH_PYTHON -B - > OUTPUT
1042 }
1043
1044 test_ruby() {
1045     MAIL_DIR=$MAIL_DIR $NOTMUCH_RUBY -I $NOTMUCH_SRCDIR/bindings/ruby> OUTPUT
1046 }
1047
1048 test_C () {
1049     exec_file="test${test_count}"
1050     test_file="${exec_file}.c"
1051     cat > ${test_file}
1052     ${TEST_CC} ${TEST_CFLAGS} -I${NOTMUCH_SRCDIR}/test -I${NOTMUCH_SRCDIR}/lib -o ${exec_file} ${test_file} -L${NOTMUCH_BUILDDIR}/lib/ -lnotmuch -ltalloc
1053     echo "== stdout ==" > OUTPUT.stdout
1054     echo "== stderr ==" > OUTPUT.stderr
1055     ./${exec_file} "$@" 1>>OUTPUT.stdout 2>>OUTPUT.stderr
1056     notmuch_dir_sanitize OUTPUT.stdout OUTPUT.stderr > OUTPUT
1057 }
1058
1059
1060 # Creates a script that counts how much time it is executed and calls
1061 # notmuch.  $notmuch_counter_command is set to the path to the
1062 # generated script.  Use notmuch_counter_value() function to get the
1063 # current counter value.
1064 notmuch_counter_reset () {
1065         notmuch_counter_command="$TMP_DIRECTORY/notmuch_counter"
1066         if [ ! -x "$notmuch_counter_command" ]; then
1067                 notmuch_counter_state_path="$TMP_DIRECTORY/notmuch_counter.state"
1068                 cat >"$notmuch_counter_command" <<EOF || return
1069 #!/bin/sh
1070
1071 read count < "$notmuch_counter_state_path"
1072 echo \$((count + 1)) > "$notmuch_counter_state_path"
1073
1074 exec notmuch "\$@"
1075 EOF
1076                 chmod +x "$notmuch_counter_command" || return
1077         fi
1078
1079         echo 0 > "$notmuch_counter_state_path"
1080 }
1081
1082 # Returns the current notmuch counter value.
1083 notmuch_counter_value () {
1084         if [ -r "$notmuch_counter_state_path" ]; then
1085                 read count < "$notmuch_counter_state_path"
1086         else
1087                 count=0
1088         fi
1089         echo $count
1090 }
1091
1092 test_reset_state_ () {
1093         test -z "$test_init_done_" && test_init_
1094
1095         test_subtest_known_broken_=
1096         test_subtest_missing_external_prereq_=()
1097 }
1098
1099 # called once before the first subtest
1100 test_init_ () {
1101         test_init_done_=t
1102
1103         # skip all tests if there were external prerequisites missing during init
1104         test_check_missing_external_prereqs_ "all tests in $this_test" && test_done
1105 }
1106
1107
1108 # Where to run the tests
1109 TEST_DIRECTORY=$NOTMUCH_BUILDDIR/test
1110
1111 . "$NOTMUCH_SRCDIR/test/test-lib-common.sh" || exit 1
1112
1113 emacs_generate_script
1114
1115
1116 # Use -P to resolve symlinks in our working directory so that the cwd
1117 # in subprocesses like git equals our $PWD (for pathname comparisons).
1118 cd -P "$TMP_DIRECTORY" || error "Cannot set up test environment"
1119
1120 if test "$verbose" = "t"
1121 then
1122         exec 4>&2 3>&1
1123 else
1124         exec 4>test.output 3>&4
1125 fi
1126
1127 for skp in $NOTMUCH_SKIP_TESTS
1128 do
1129         to_skip=
1130         for skp in $NOTMUCH_SKIP_TESTS
1131         do
1132                 case "$this_test" in
1133                 $skp)
1134                         to_skip=t
1135                         break
1136                 esac
1137                 case "$this_test_bare" in
1138                 $skp)
1139                         to_skip=t
1140                         break
1141                 esac
1142         done
1143         case "$to_skip" in
1144         t)
1145                 say_color skip >&3 "skipping test $this_test altogether"
1146                 say_color skip "skip all tests in $this_test"
1147                 test_done
1148         esac
1149 done
1150
1151 # Provide an implementation of the 'yes' utility
1152 yes () {
1153         if test $# = 0
1154         then
1155                 y=y
1156         else
1157                 y="$*"
1158         fi
1159
1160         while echo "$y"
1161         do
1162                 :
1163         done
1164 }
1165
1166 # Fix some commands on Windows
1167 case $(uname -s) in
1168 *MINGW*)
1169         # Windows has its own (incompatible) sort and find
1170         sort () {
1171                 /usr/bin/sort "$@"
1172         }
1173         find () {
1174                 /usr/bin/find "$@"
1175         }
1176         sum () {
1177                 md5sum "$@"
1178         }
1179         # git sees Windows-style pwd
1180         pwd () {
1181                 builtin pwd -W
1182         }
1183         # no POSIX permissions
1184         # backslashes in pathspec are converted to '/'
1185         # exec does not inherit the PID
1186         ;;
1187 *)
1188         test_set_prereq POSIXPERM
1189         test_set_prereq BSLASHPSPEC
1190         test_set_prereq EXECKEEPSPID
1191         ;;
1192 esac
1193
1194 test -z "$NO_PERL" && test_set_prereq PERL
1195 test -z "$NO_PYTHON" && test_set_prereq PYTHON
1196
1197 # test whether the filesystem supports symbolic links
1198 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
1199 rm -f y
1200
1201 # convert variable from configure to more convenient form
1202 case "$NOTMUCH_DEFAULT_XAPIAN_BACKEND" in
1203     glass)
1204         db_ending=glass
1205     ;;
1206     chert)
1207         db_ending=DB
1208     ;;
1209     *)
1210         error "Unknown Xapian backend $NOTMUCH_DEFAULT_XAPIAN_BACKEND"
1211 esac
1212 # declare prerequisites for external binaries used in tests
1213 test_declare_external_prereq dtach
1214 test_declare_external_prereq emacs
1215 test_declare_external_prereq ${TEST_EMACSCLIENT}
1216 test_declare_external_prereq ${TEST_GDB}
1217 test_declare_external_prereq gpg
1218 test_declare_external_prereq openssl
1219 test_declare_external_prereq gpgsm
1220 test_declare_external_prereq ${NOTMUCH_PYTHON}